#include <atomic>
#include <cassert>
#include <coyote.hpp>
#include <iostream>

using namespace coyote;

int main() {
    coyote_init("", 4); // use 4 threads
    Coyote coyote("test_simple");

    coyote.def_grid({{4}}, {{0.0, 0.0, 1.0, 1.0}}, {{0.0, 1.0, 1.0, 0.0}}, {{0, 1, 2, 3}});

    std::atomic_int task_count    = 0;
    std::atomic_int subtask_count = 0;
    coyote.add_field(
        "simple_source",
        "simple_grid",
        "clock",
        [&](Event ev) {
            task_count++;
            coyote_add_task([&]() { subtask_count++; });
        },
        "PT2S",
        1);

    coyote_run();

    std::cout << task_count << std::endl;
    assert(task_count == subtask_count);
    return 0;
}
