#!/usr/bin/python3

import numpy as np
from coyote import Coyote, add_task, run

coyote = Coyote("test_simple")

coyote.def_grid([4], [0.0, 0.0, 1.0, 1.0], [0.0, 1.0, 1.0, 0.0], [0, 1, 2, 3], [0.5], [0.5])

s = np.zeros(shape=(1, 1), dtype=np.float64)


def handler(event):
    data = np.asarray(event.data).copy()

    def task():
        global s
        s[:] += data

    add_task(task, 0)


coyote.add_field("simple_source", "simple_grid", "clock", handler, "PT2S")

run()

print(s)
